package com.example.chat.service;

import com.example.chat.dao.UserMapper;
import com.example.chat.dao.redis.RedisUtil;
import com.example.chat.entity.User;
import com.example.chat.jwt.JWTUtil;
import org.junit.Test;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.IOException;


@Service
public class LoginService {
    @Resource
    UserMapper userTable;
    @Resource(name = "tokenRedis")
    RedisUtil redisUtil;

    @Test
    public void Test01() throws IOException {
        System.out.println(userTable.getUser(new User()));
    }

    public String LoginCheck(User requestUser) throws IOException {
        User user;
        user = userTable.getUser(requestUser);
        System.out.println(user);
        System.out.println(requestUser);
        if (user != null) {
            if (user.getPassword().equals(requestUser.getPassword())) {
                String token = JWTUtil.sign(user.getAccount());
                redisUtil.addRedis(user.getAccount(), token);
                return token;
            } else return null;
        } else {
            return null;
        }
    }

    public int Register(User requestUser) throws IOException {
        int returnInt = 0;
        User user;
        user = userTable.getUser(requestUser);
        User emailUser = userTable.emailCheck(requestUser);
        if (user != null) {
            System.out.println("注册有问题");
            if (user.getAccount().equals(requestUser.getAccount())) {
                returnInt = 1001;//账号已存在
            }
//            else if (user.getUsername().equals(requestUser.getUsername())) {
//                returnInt = 1003;//该用户名已被占用
//            }
        } else if (emailUser != null) {
            if (emailUser.getEmail().equals(requestUser.getEmail())) {
                returnInt = 1002;
            }
        } else {
            requestUser.setUsername(requestUser.getAccount());
            userTable.addUser(requestUser);
            returnInt = 200;
        }
        return returnInt;

    }
}
