package com.example.chat.service.mail;

import com.example.chat.dao.redis.CodeRedis;
import com.example.chat.dao.redis.RedisUtil;
import com.example.chat.service.CodeCreate;
import com.sun.mail.util.MailSSLSocketFactory;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.mail.*;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import java.security.GeneralSecurityException;
import java.util.Properties;

@Service
public class MailUtil {
    @Resource
    CodeCreate codeCreate;
    @Resource(name = "codeRedis")
    RedisUtil redisUtil;

    public void sendMail(String receive) {
        String code = codeCreate.CreateCode();
        Properties prop = new Properties();
        //开启debug调试
//        prop.setProperty("mail.debug", "true");
        //设置邮件服务器主机名
        prop.setProperty("mail.host", "smtp.qq.com");
        //发送服务器需要身份验证
        prop.setProperty("mail.smtp.auth", "true");
        //发送邮件协议
        prop.setProperty("mail.transport.protocol", "smtp");
        try {
            MailSSLSocketFactory sslSocketFactory = new MailSSLSocketFactory();
            //不对服务器主机名进行验证
            sslSocketFactory.setTrustAllHosts(true);
            //启用ssl加密
            prop.put("mail.smtp.ssl.enable", "true");
            prop.put("mail.smtp.ssl.socketFactory", sslSocketFactory);
            Session session = Session.getInstance(prop);
            Transport transport = session.getTransport();
            transport.connect("smtp.qq.com", "747682928@qq.com", "ykrtsjznfvcobfaj");
            Message message = createSimpleMail(session, receive, code);
            transport.sendMessage(message, message.getAllRecipients());
            transport.close();
            redisUtil.addRedis(receive, code);
        } catch (GeneralSecurityException | MessagingException e) {
            throw new RuntimeException(e);
        }
    }

    private MimeMessage createSimpleMail(Session session, String receive, String code) throws MessagingException {

        MimeMessage message = new MimeMessage(session);
        message.setFrom(new InternetAddress("747682928@qq.com"));
        message.setRecipient(Message.RecipientType.TO, new InternetAddress(receive));

        //设置邮件标题
        message.setSubject("ChatABC");
        //设置邮件内容
        message.setContent("感谢您在ChatABC的注册,这是您的注册验证码," + code + "<br>如非本人操作，请忽略！请勿回复此邮箱", "text/html;charset=UTF-8");
        return message;

    }
}
